ContributorFact
A ContributorFact contains a selection of high-level statistics about a person who commited source code to a Project. One ContributorFact record exists for each contributor.
A ContributorFact is part of an Analysis, and is derived from lower-level statistics contained within the Analysis.
A new ContributorFact is created for each Project contributor whenever a new Analysis is created for the Project.
ContributorFacts only exist after Ohloh has downloaded and analyzed the project source code.
Properties
- analysis_id
- The unique ID for the Analysis which provided the source data for this ContributorFact.
- contributor_id
- The ID for the person who contributed the code measured in this ContributorFact. The
contributor_id is not globally unique. It is derived from the author name found in the source control server log, and is unique within the scope of an individual project only.
- contributor_name
- The name used by the author of this code when committing to the source control server.
- account_id
- If this contribution has been claimed by an Ohloh member, the element contains the unique ID of the Ohloh Account. Otherwise, this element is omitted.
- account_name
- If this contribution has been claimed by an Ohloh member, this element contains the Account name. Otherwise, this element is omitted.
- primary_language_id
- The unique ID of the Language most often used by this contributor, measured by the number of code lines added. If this contributor has not committed any code in a language which Ohloh can recognize, this value will be null.
- primary_language_nice_name
- The
nice_name of the Language specified by primary_language_id.
- comment_ratio
- The fraction of new lines added by this contributor which are comments. Note that Ohloh does not track the net lines of current code attributable to an specific individual. This statistic merely sums over all new lines added, and does not consider whether the added lines were later removed by this contributor or any other.
- first_commit_time
- The time of the first commit by this contributor.
- last_commit_time
- The time of the last commit by this contributor.
- man_months
- The total number of calendar months in which this contributor made at least one commit. Note that this is not simply the number of months between
first_commit_time and last_commit_time: months in which there was no activity for this contributor are not counted.
- commits
- The total number of commits made by this contributor.
- median_commits
- Considering only months in which this contributor made at least one commit, this is the median number of commits in a single month by this contributor.
- contributor_language_facts
- A collection of ContributorLanguageFacts may be included here, covering statistics in individual Languages. This collection is only present when ContributorFacts are queried individually.
URL
To get a single ContributorFact based on the latest Analysis for a Project:
GET http://www.ohloh.net/projects/{project_id}/contributors/{contributor_id}.xml
This ContributorFact will include within it a collection of ContributorLanguageFacts covering statistics for individual languages.
Collection URL
To get a list of all ContributorFacts based on the lastest Analysis for a Project:
GET http://www.ohloh.net/projects/{project_id}/contributors.xml
ContributorFacts returned from this call will not include ContributorLanguageFacts. Those can be obtained by retrieving ContributorFacts individually only.
The project collection request supports the standard collection request parameters, with the following details:
- query
- If supplied, only ContributorFacts with a matching
contributor_name will be returned. Ohloh account names are not matched.
- sort
- ContributorFact collections support the following sort options:
- name
- name_reverse
- commits
- commits_reverse (default)
- comment_ratio
- comment_ratio_reverse
- person_months
- person_months_reverse